import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is a starter code sample for creating an Animated Character.
 * 
 * It contains all of the required elements and nothing more. NOTHING
 * in this template should be deleted, unless you really know what you're doing.
 * 
 * Simply copy and rename this class to get started. 
 * 
 * @author Jordan Cohen 
 * @version v1.0.0_alpha1
 * @since v1.0.0
 */
public class Charger extends AnimatedCharacter
{
    private int walkSpeed, walkAnimSpeed, chargeSpeed, chargeAnimSpeed;
    private boolean charging;

    public Charger () {

        walkSpeed = 60; // pixels to move per SECOND (not per act)
        walkAnimSpeed = 20; // number of animations frames per SECOND 
        chargeSpeed = 180; // CHARGE movement speed
        chargeAnimSpeed = 30; // CHARGE animation speed


        
        // set the speed to start
        changeSpeed(walkSpeed, walkAnimSpeed);

        charging = false;

        //  =-== SETUP ANIMATIONS ==-=

        // First, create my sprite sheets
        setLayer(0, new GreenfootImage("skeleton.png"));
        setLayer(1, new GreenfootImage("plate_chest_male.png"));
        setLayer(2, new GreenfootImage("plate_pants_male.png"));
        setLayer(3, new GreenfootImage("metal_gloves_male.png"));
        setLayer(4, new GreenfootImage("dagger_male.png"));

        // use Animation methods to build two animations:
        // a walking animation for our primary animation / movement
        animations.put ("move", Animation.createWalkingAnimation(getSpriteSheet()));
        // a swing animation for swinging a weapon or tool
        animations.put ("charge", Animation.createAnimation(getSpriteSheet(), 13, 4, 6, 64, 64));

        primaryAnimation = animations.get("move");

        // REPLACE THIS LINE to assign a starting image for your Actor.
        setImage(primaryAnimation.getOneImage(direction, 0));

        // create a custom collider (width, height, xOffset, yOffset)
        setCollider (28, 40, 0, 6);
        enableCollision();
    }

    /**
     * Many people don't even know that this exists. This method is automatically called when an object is added to the World,
     * and the parameter w represents that World. It can be very useful. If you don't intend to have an addedToWorld method,
     * just leave this alone. You could delete it, as the superclass' version will be called automatically. However, if you have 
     * your own addedToWorld method, you must call super.addedToWorld as shown here.
     */
    public void addedToWorld (World w){
        super.addedToWorld(w);

        // Your code here.

    }

    /**
     * Act - do whatever the Charger wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if (!charging){
            int rand = Greenfoot.getRandomNumber(200);
            if (rand == 0){
                charge();
            } else if (rand == 1){
                if(getWorld().getObjects(ComplexPlayer.class).size() != 0){
                    ComplexPlayer cp = getWorld().getObjects(ComplexPlayer.class).get(0);
                    charge (cp.getX(), cp.getY());
                }
            }
        }

        if ( isColliding() ){

            Actor a = checkCollision();
            stopMoving();
            //stepBack(a);
            charging = false;
        }

        // This will perform the motion and animation, and must be at the end of your act() method:
        super.act();
    }    

    private void charge () {
        charging = true;

        int xDestination = Greenfoot.getRandomNumber (getWorld().getWidth());
        int yDestination = Greenfoot.getRandomNumber (getWorld().getHeight());

        charge(xDestination, yDestination);
    }

    private void charge (int xT, int yT){
        changeSpeed(chargeSpeed, chargeAnimSpeed);
        currentAnimation = animations.get("charge");
        moveTowards (xT, yT);
    }


    /**
     * This method will be called by AnimatedCharacter when a terminal animation has finished running. For example,
     * if you have a terminal animation for swinging a weapon, when the weapon swing is over, this method will be called.
     * This is a good place to take appropriate action (such as setting attacking = false) or start the next animation.
     */
    protected void terminalAnimationComplete () {

    }

    protected void movementComplete() {
        charging = false;
        currentAnimation = primaryAnimation;
        changeSpeed(walkSpeed, walkAnimSpeed);
    }
}
